#include "MonochromeLib.h"
#include "stdlib.h"
#include "string.h"
#include "libAnim.h"
//fonctions d'initialisation
seq* initSeq(char n, char isTemp, char* id, unsigned char* *bitmap)
{
	seq* new = malloc(sizeof(seq));
	if(new == NULL) return NULL;
	new->n = n-1;
	new->isTemp = isTemp;
	new->id = id;
	new->bitmap = bitmap;
	return new;
}
objet* initObjet(seq* *s, char nb, char x, char y, char sizeX, char sizeY)
{
	objet* new = malloc(sizeof(objet));
	if(new == NULL) return NULL;
	coords* newC = malloc(sizeof(coords));
	if(newC == NULL) return NULL;
	newC->x = x;
	newC->y = y;
	newC->sizeX = sizeX;
	newC->sizeY = sizeY;
	new->c = newC;
	new->locked = 0;
	new->nb = nb-1;
	new->current = 0;
	new->n = 0;
	new->s = s;
	return new;
}
//fonction d'utilisation
void drawCurrent(objet* o)
{
	if(o->c->sizeX == o->c->sizeY)
		if(o->c->sizeX == 8)
		ML_bmp_8_or_cl(o->s[o->current]->bitmap[o->n],o->c->x, o->c->y);
		else if(o->c->sizeX == 16)
		ML_bmp_16_or_cl(o->s[o->current]->bitmap[o->n],o->c->x, o->c->y);
		else
		ML_bmp_or_cl(o->s[o->current]->bitmap[o->n],o->c->x, o->c->y, o->c->sizeX, o->c->sizeY);
}
void updateCurrent(objet* o)
{

	if(o->n == o->s[o->current]->n)
	{
		o->n = 0;
		if(o->locked) o->locked = 0;
		if(o->s[o->current]->isTemp == 1)
		{
			o->current = 0;
			o->locked = 1;
		}
	}
	else o->n++;
}
char triggerAnim(objet* o, char* id, char priority)
{
	int i = 0, j = 0, found = 0;
	for(i = 0; i <= o->nb;i++)
		if(strcmp(id, o->s[i]->id)==0)
				break;
			
	if(strcmp(id, o->s[i]->id)==0)
	{
			o->locked = 1;
			o->current = i;
			o->n = 0;
		return 1;
	}
	else return 0;
}
//fonctions de libration
seq* freeSeq(seq* s)
{
	free(s);
	return NULL;
}
objet* freeObjet(objet* o)
{
	free(o->c);
	free(o);
	return NULL;
}
objet* freeObjetR(objet* o)
{
	int i = 0;
	free(o->c);
	for(i = 0; i <= o->nb; i++)
		free(o->s[i]);
	free(o);
	return NULL;
}