/**
libAnim
v 1.0 - par Adbook
**/
#ifndef LIBANIM_H
typedef struct coords coords;
struct coords{
char x;
char y;
char sizeX;
char sizeY;
};
typedef struct seq seq;
struct seq{
char n; //nombre de bitmaps 
char isTemp; //savoir si il faut l'excuter une fois ou en boucle
char* id; //nom de la squence
unsigned char* *bitmap; //tableau de pointeurs de bitmaps
};
typedef struct objet objet;
struct objet{
coords* c; //structure de coordonnes + taille
char nb; //taille du tableau de squences
char locked; //vous indique si une animation n'a pas t entierement excute
char current; //valable si locked>0: id de la squence en cours
char n; //id du bitmap dans la sequence en cours
seq* *s; //tableau de squences
};
/**fonctions d'initialisation**/
//renvoie un pointeur vers le seq cr. les arguments correspondent aux attributs de la structure. Ne pas oublier de librer toutes les seq cres
seq* initSeq(char n, char isTemp, char* id, unsigned char* *bitmap);

//renvoie un pointeur vers l'objet cr. les arguments correspondent aux attributs de la structure. Ne pas oublier de librer tous les objets crs
objet* initObjet(seq* *s, char nb, char x, char y, char sizeX, char sizeY);

/**fonctions d'utilisation**/
//affiche dans la VRAM l'objet dans l'tat d'animation o il est.  utiliser avant updateCurrent
void drawCurrent(objet* o);

// appeler aprs drawCurrent: actualise l'objet
void updateCurrent(objet* o);

//change l'animation d'un programme.
//id est le nom de la seq
//priority ne sert pas pour le moment
//retourne 0 si l'id ne correspond pas  une seq, 1 sinon
char triggerAnim(objet* o, char* id, char priority);

/**fonctions de libration**/
//Pour librer une squence
seq* freeSeq(seq* s);

//Libre un objet
objet* freeObjet(objet* o);

//Libre un objt + toutes les squences qu'il contient (Ne pas utiliser si vous utilisez les memes squences pour plusieurs objets)
objet* freeObjetR(objet* o);
#define LIBANIM_H
#endif